; ________________________________________________
; | Costanti per programma scheda didattica 8 led|
; |______________________________________________|
; |   Header File                                |
; |______________________________________________|
; |   Tipo      : INC                            |
; |   Versione  : 1                              |
; |   Release   : 0                              |
; |   Autore    : Lain Walter                    |
; |   Data      : 28/12/06                       |
; |______________________________________________|

;_______________________________________________________Costanti
#define c_FIRST_LED     0x7F            ;primo led acceso
#define c_LAST_LED      0xFE            ;ultimo led acceso
#define c_EXT_LED       0x7E            ;primo ed ultimo led acceso
#define c_ST_MASK       0x02            ;maschera per clear stato programmi

#define c_RLED_TRIS     TRISA           ;pin del led
#define c_RLED_PORT     PORTA
#define c_RLED_PIN      1

;_______________________________________________________Pulsanti
#define c_SW_SEL_TRIS     TRISA         ;pulsante di selezione
#define c_SW_SEL_PORT     PORTA
#define c_SW_SEL_PIN      0

#define c_SW_STST_TRIS    TRISA         ;pin del led
#define c_SW_STST_PORT    PORTA
#define c_SW_STST_PIN     2

#define c_SW_BIT          6             ;bit da controllare per buffer tasti
                                        ; con il clock a 1ms, occorrono 64ms
                                        ; per un cambio stato del pulsante

;_______________________Timer Principale
;timer principale di sistema (0x03E8 = 1 ms)
;clock=4MHz --> tmr=1MHz / 1us
; Dato che il timer incrementa fino a FFFF e poi va in IRQ, devo sottrarre
; il valore che mi serve da FFFF e quindi usare il risultato
#define c_TMR_TIME_H      0xFC          ;timer principale
#define c_TMR_TIME_L      0x17          ;
;_______________________Divisori timer principale
#define c_TMR_TIME2       0x96          ;divisore timer 2 (150ms)

;_______________________PWM per "supercar"
#define c_TMR_PWM1        0x03          ;valore per led vicino (tanta luce)
#define c_TMR_PWM2        0x18          ;valore per led remoto (poca luce)

;_______________________________________________________Flags
#define f_CTR_DIR         b_CONTROLLO,0 ;controllo direzione
#define f_CTR_RUN         b_CONTROLLO,1 ;flag di esecuzione programmi
#define f_CTR_5PW         b_CONTROLLO,2 ;flag esecuzione PWM PROG5
#define f_CTR_P5          b_CONTROLLO,3 ;flag esecuzione PROG5
#define f_CTR_P4          b_CONTROLLO,4 ;flag esecuzione PROG4
#define f_CTR_P3          b_CONTROLLO,5 ;flag esecuzione PROG3
#define f_CTR_P2          b_CONTROLLO,6 ;flag esecuzione PROG2
#define f_CTR_P1          b_CONTROLLO,7 ;flag esecuzione PROG1

#define f_ST_CHG          b_STATO,0     ;flag cambio stato
#define f_CTR_P6          b_STATO,1     ;flag esecuzione PROG6 (aggiunto dopo)
#define f_ST_P6           b_STATO,2     ;flag stato PROG6
#define f_ST_P5           b_STATO,3     ;flag stato PROG5
#define f_ST_P4           b_STATO,4     ;flag stato PROG4
#define f_ST_P3           b_STATO,5     ;flag stato PROG3
#define f_ST_P2           b_STATO,6     ;flag stato PROG2
#define f_ST_P1           b_STATO,7     ;flag stato PROG1

#define f_SW_SEL_STAT     b_SW_CTRL,0   ;flag di stato pulsante selezione
#define f_SW_SEL_CHG      b_SW_CTRL,1   ;flag di cambio stato pulsante selezione
#define f_SW_ST_STAT      b_SW_CTRL,2   ;flag di stato pulsante start/stop
#define f_SW_ST_CHG       b_SW_CTRL,3   ;flag di cambio stato pulsante start/stop

#define f_TIMER1_ON       b_TMR_FLAGS,0 ;flag IRQ timer1
#define f_TIMER2_ON       b_TMR_FLAGS,1 ;flag divisore timer2

