; ________________________________________________
; |   Sub per programma scheda didattica 8 led   |
; |______________________________________________|
; |   Src File                                   |
; |______________________________________________|
; |   Tipo      : INC                            |
; |   Versione  : 1                              |
; |   Release   : 0                              |
; |   Autore    : Lain Walter                    |
; |   Data      : 28/12/06                       |
; |______________________________________________|

Prog1:
;Questa routine esegue il programma "up"
;Registri modificati:
;       sistema
;       b_CONTROLLO
;       R3H
;       PORTA
;       PORTB
;metodo di chiamata:
;       MOVLF dato,R3H
;       CALL Prog1
;
        BSF STATUS,C                    ;set carry
        RLF R3H,F                       ;UP byte
        BTFSS STATUS,C                  ;Controllo stato carry
        RLF R3H,F                       ;sono arrivato alla fine, torno all'inizio
        BCF f_CTR_P1                     ;clear flag esecuzione Programma
        CALL Port_Write                 ;Scrive sulle uscite
        RETURN                          ;fine

Prog2:
;Questa routine esegue il programma "down"
;Registri modificati:
;       sistema
;       b_CONTROLLO
;       R3H
;       PORTA
;       PORTB
;metodo di chiamata:
;       MOVLF dato,R3H
;       CALL Prog2
;
        BSF STATUS,C                    ;set carry
        RRF R3H,F                       ;DOWN byte
        BTFSS STATUS,C                  ;Controllo stato carry
        RRF R3H,F                       ;sono arrivato alla fine, torno all'inizio
        BCF f_CTR_P2                    ;clear flag esecuzione Programma
        CALL Port_Write                 ;Scrive sulle uscite
        RETURN                          ;fine

Prog3:
;Questa routine esegue il programma "up/down"
;Registri modificati:
;       sistema
;       b_CONTROLLO
;       R3H
;       PORTA
;       PORTB
;metodo di chiamata:
;       MOVLF dato,R3H
;       BCF CTR_DIR
;       CALL Prog3
;
;
        BTFSC f_CTR_DIR                 ;Controllo direzione
        GOTO P3_DR1                     ; dir1 (DOWN)
        BSF STATUS,C                    ;set carry
        RLF R3H,F                       ; dir0 (UP)
        BTFSS STATUS,C                  ;controllo se arrivato alla fine
        GOTO P3_C01                     ; si, cambio direzione
        GOTO P3_END                     ; no, termina sub
P3_DR1  BSF STATUS,C                    ;dir1 (DOWN)
        RRF R3H,F                       ;
        BTFSS STATUS,C                  ;controllo se arrivato alla fine
        GOTO P3_C10                     ; si, cambio direzione
        GOTO P3_END                     ; no, termina sub
P3_C01  BSF f_CTR_DIR                   ;setto dir1 (DOWN)
        RRF R3H,F                       ;recupero carry
        RRF R3H,F                       ;indietro di 1
        GOTO P3_END                     ;termina sub
P3_C10  BCF f_CTR_DIR                   ;setto dir0 (UP)
        RLF R3H,F                       ;recupero carry
        RLF R3H,F                       ;avanti di 1
P3_END  BTFSC f_ST_P5                   ;controlla se in esecuzione P3 o P5
        GOTO P3_PR5                     ; P5, salta il port write ed esce
        BCF f_CTR_P3                    ; P3, clear flag esecuzione Programma
        CALL Port_Write                 ;Scrive sulle uscite
P3_PR5  RETURN                          ;fine

Prog4:
;Questa routine esegue il programma "cross"
; Sono necessari 2 bytes per i movimenti temporanei
;Registri modificati:
;       sistema
;       R0H
;       R0L
;       b_CONTROLLO
;       R3H
;       PORTA
;       PORTB
;metodo di chiamata:
;       MOVLF c_FIRST_LED,R3H
;       MOVLF c_LAS_LED,R0H
;       MOVLF c_EXT_LED,R0L
;       CALL Prog4
;
        BSF STATUS,C                    ;set carry
        RLF R0H,F                       ;UP byte1
        BTFSC STATUS,C                  ;Controlla stato carry
        GOTO P4_001                     ;prosegue
        MOVLF 0xFD,R0H                  ;e' arrivato alla fine, torna all'inizio
P4_001  BSF STATUS,C                    ;set carry
        RRF R0L,F                       ;DOWN byte2
        BTFSC STATUS,C                  ;Controlla stato carry
        GOTO P4_002                     ;prosegue
        MOVLF 0xBF,R0L                  ;e' arrivato alla fine, torna all'inizio
P4_002  MOVF R0H,W                      ;carica byte1 in W
        ANDWF R0L,W                     ;byte1 AND byte2 --> W
        MOVWF R3H                       ;copia il risultato in PORTB
        BCF f_CTR_P4                    ;clear flag esecuzione Programma
        CALL Port_Write                 ;Scrive sulle uscite
        RETURN                          ;fine

Prog5:
;Questa routine esegue il programma "supercar"
;Di base è il Prog3, con l'aggiunta di una specie di PWM sui 2
; led precedenti e successivi al led attivo.
;Il "PWM" è al 50% sui 2 led vicini e al 33% sui 2 led lontani 
;Registri modificati:
;       sistema
;       R3L
;       R3H
;       PORTA
;       PORTB
;       b_CONTROLLO
;       b_P5_PWM
;metodo di chiamata:
;       MOVLF 0xFF,R3H
;       BCF CTR_DIR
;       CALL Prog5
;
        BTFSC f_CTR_P5                  ;Controlla se deve eseguire anche il prog.
        CALL Prog3                      ; si, esegue...
        MOVFF R3H,R3L                   ; no, salva una copia di R3H prima del "PWM"
        INCF b_P5_PWM1,F                ;incrementa contatori PWM
        INCF b_P5_PWM2,F                ;
        BTFSS R3H,0                     ;controlla quale bit è attivo
        GOTO P5_BIT0                    ; Bit0
        BTFSS R3H,1                     ;
        GOTO P5_BIT1                    ; Bit1
        BTFSS R3H,2                     ;
        GOTO P5_BIT2                    ; Bit2
        BTFSS R3H,3                     ;
        GOTO P5_BIT3                    ; Bit3
        BTFSS R3H,4                     ;
        GOTO P5_BIT4                    ; Bit4
        BTFSS R3H,5                     ;
        GOTO P5_BIT5                    ; Bit5
        BTFSS R3H,6                     ;
        GOTO P5_BIT6                    ; Bit6
        BTFSS R3H,7                     ;
        GOTO P5_BIT7                    ; Bit7
;Bit0, PWM su Bit1 e Bit2
P5_BIT0 MOVF b_P5_PWM1,W                ;verifica contatore PWM1
        SUBLW c_TMR_PWM1                ;
        BZ P5_B001                      ; raggiunto livello
        BSF R3H,1                       ; non raggiunto, disattiva Bit1
        GOTO P5_B002                    ;prosegue
P5_B001 BCF R3H,1                       ;attiva Bit1
        CLRF b_P5_PWM1                  ;reset contatore
P5_B002 MOVF b_P5_PWM2,W                ;verifica contatore PWM2
        SUBLW c_TMR_PWM2                ;
        BZ P5_B003                      ; raggiunto livello
        BSF R3H,2                       ; non raggiunto, disattiva Bit2
        GOTO P5_END                     ;fine sub
P5_B003 BCF R3H,2                       ;attiva Bit2
        CLRF b_P5_PWM2                  ;reset contatore
        GOTO P5_END                     ;fine sub
;Bit1, PWM su Bit0,Bit2 e Bit3
P5_BIT1 MOVF b_P5_PWM1,W                ;verifica contatore PWM1
        SUBLW c_TMR_PWM1                ;
        BZ P5_B101                      ; raggiunto livello
        BSF R3H,0                       ; non raggiunto, disattiva Bit0 e Bit2
        BSF R3H,2                       ;
        GOTO P5_B102                    ;prosegue
P5_B101 BCF R3H,0                       ;attiva Bit0 e Bit2
        BCF R3H,2                       ;
        CLRF b_P5_PWM1                  ;reset contatore
P5_B102 MOVF b_P5_PWM2,W                ;verifica contatore PWM2
        SUBLW c_TMR_PWM2                ;
        BZ P5_B103                      ; raggiunto livello
        BSF R3H,3                       ; non raggiunto, disattiva Bit3
        GOTO P5_END                     ;fine sub
P5_B103 BCF R3H,3                       ;attiva Bit3
        CLRF b_P5_PWM2                  ;reset contatore
        GOTO P5_END                     ;fine sub
;Bit2, PWM su Bit1,Bit3 e Bit0,Bit4
P5_BIT2 MOVF b_P5_PWM1,W                ;verifica contatore PWM1
        SUBLW c_TMR_PWM1                ;
        BZ P5_B201                      ; raggiunto livello
        BSF R3H,1                       ; non raggiunto, disattiva Bit1 e Bit3
        BSF R3H,3                       ;
        GOTO P5_B202                    ;prosegue
P5_B201 BCF R3H,1                       ;attiva Bit1 e Bit3
        BCF R3H,3                       ;
        CLRF b_P5_PWM1                  ;reset contatore
P5_B202 MOVF b_P5_PWM2,W                ;verifica contatore PWM2
        SUBLW c_TMR_PWM2                ;
        BZ P5_B203                      ; raggiunto livello
        BSF R3H,0                       ; non raggiunto, disattiva Bit0 e Bit4
        BSF R3H,4                       ;
        GOTO P5_END                     ;fine sub
P5_B203 BCF R3H,0                       ;attiva Bit0 e Bit4
        BCF R3H,4                       ;
        CLRF b_P5_PWM2                  ;reset contatore
        GOTO P5_END                     ;fine sub
;Bit3, PWM su Bit2,Bit4 e Bit1,Bit5
P5_BIT3 MOVF b_P5_PWM1,W                ;verifica contatore PWM1
        SUBLW c_TMR_PWM1                ;
        BZ P5_B301                      ; raggiunto livello
        BSF R3H,2                       ; non raggiunto, disattiva Bit2 e Bit4
        BSF R3H,4                       ;
        GOTO P5_B302                    ;prosegue
P5_B301 BCF R3H,2                       ;attiva Bit2 e Bit4
        BCF R3H,4                       ;
        CLRF b_P5_PWM1                  ;reset contatore
P5_B302 MOVF b_P5_PWM2,W                ;verifica contatore PWM2
        SUBLW c_TMR_PWM2                ;
        BZ P5_B303                      ; raggiunto livello
        BSF R3H,1                       ; non raggiunto, disattiva Bit1 e Bit5
        BSF R3H,5                       ;
        GOTO P5_END                     ;fine sub
P5_B303 BCF R3H,1                       ;attiva Bit1 e Bit5
        BCF R3H,5                       ;
        CLRF b_P5_PWM2                  ;reset contatore
        GOTO P5_END                     ;fine sub
;Bit4, PWM su Bit3,Bit5 e Bit2,Bit6
P5_BIT4 MOVF b_P5_PWM1,W                ;verifica contatore PWM1
        SUBLW c_TMR_PWM1                ;
        BZ P5_B401                      ; raggiunto livello
        BSF R3H,3                       ; non raggiunto, disattiva Bit3 e Bit5
        BSF R3H,5                       ;
        GOTO P5_B402                    ;prosegue
P5_B401 BCF R3H,3                       ;attiva Bit3 e Bit5
        BCF R3H,5                       ;
        CLRF b_P5_PWM1                  ;reset contatore
P5_B402 MOVF b_P5_PWM2,W                ;verifica contatore PWM2
        SUBLW c_TMR_PWM2                ;
        BZ P5_B403                      ; raggiunto livello
        BSF R3H,2                       ; non raggiunto, disattiva Bit2 e Bit6
        BSF R3H,6                       ;
        GOTO P5_END                     ;fine sub
P5_B403 BCF R3H,2                       ;attiva Bit2 e Bit6
        BCF R3H,6                       ;
        CLRF b_P5_PWM2                  ;reset contatore
        GOTO P5_END                     ;fine sub
;Bit5, PWM su Bit4,Bit6 e Bit3,Bit7
P5_BIT5 MOVF b_P5_PWM1,W                ;verifica contatore PWM1
        SUBLW c_TMR_PWM1                ;
        BZ P5_B501                      ; raggiunto livello
        BSF R3H,4                       ; non raggiunto, disattiva Bit4 e Bit6
        BSF R3H,6                       ;
        GOTO P5_B502                    ;prosegue
P5_B501 BCF R3H,4                       ;attiva Bit4 e Bit6
        BCF R3H,6                       ;
        CLRF b_P5_PWM1                  ;reset contatore
P5_B502 MOVF b_P5_PWM2,W                ;verifica contatore PWM2
        SUBLW c_TMR_PWM2                ;
        BZ P5_B503                      ; raggiunto livello
        BSF R3H,3                       ; non raggiunto, disattiva Bit3 e Bit7
        BSF R3H,7                       ;
        GOTO P5_END                     ;fine sub
P5_B503 BCF R3H,3                       ;attiva Bit3 e Bit7
        BCF R3H,7                       ;
        CLRF b_P5_PWM2                  ;reset contatore
        GOTO P5_END                     ;fine sub
;Bit6, PWM su Bit5,Bit7 e Bit4
P5_BIT6 MOVF b_P5_PWM1,W                ;verifica contatore PWM1
        SUBLW c_TMR_PWM1                ;
        BZ P5_B601                      ; raggiunto livello
        BSF R3H,5                       ; non raggiunto, disattiva Bit5 e Bit7
        BSF R3H,7                       ;
        GOTO P5_B602                    ;prosegue
P5_B601 BCF R3H,5                       ;attiva Bit5 e Bit7
        BCF R3H,7                       ;
        CLRF b_P5_PWM1                  ;reset contatore
P5_B602 MOVF b_P5_PWM2,W                ;verifica contatore PWM2
        SUBLW c_TMR_PWM2                ;
        BZ P5_B603                      ; raggiunto livello
        BSF R3H,4                       ; non raggiunto, disattiva Bit4
        GOTO P5_END                     ;fine sub
P5_B603 BCF R3H,4                       ;attiva Bit4
        CLRF b_P5_PWM2                  ;reset contatore
        GOTO P5_END                     ;fine sub

;Bit7, PWM su Bit6 e Bit5
P5_BIT7 MOVF b_P5_PWM1,W                ;verifica contatore PWM1
        SUBLW c_TMR_PWM1                ;
        BZ P5_B701                      ; raggiunto livello
        BSF R3H,6                       ; non raggiunto, disattiva Bit6
        GOTO P5_B702                    ;prosegue
P5_B701 BCF R3H,6                       ;attiva Bit6
        CLRF b_P5_PWM1                  ;reset contatore
P5_B702 MOVF b_P5_PWM2,W                ;verifica contatore PWM2
        SUBLW c_TMR_PWM2                ;
        BZ P5_B703                      ; raggiunto livello
        BSF R3H,5                       ; non raggiunto, disattiva Bit5
        GOTO P5_END                     ;fine sub
P5_B703 BCF R3H,5                       ;attiva Bit5
        CLRF b_P5_PWM2                  ;reset contatore
        GOTO P5_END                     ;fine sub
;Fine programma, scrittura sui port
P5_END  BCF f_CTR_P5                    ;clear flag esecuzione Programma
        CALL Port_Write                 ;Scrive sulle uscite
        MOVFF R3L,R3H                   ;Ripristina R3H senza PWM
        RETURN                          ;fine

Prog6:
;Questa routine esegue il programma "blink"
;Registri modificati:
;       sistema
;       R3H
;       PORTA
;       PORTB
;metodo di chiamata:
;       CALL Prog6
;
        MOVLF 0xFF,R3H                  ;Spegne tutti i led
        BTFSS c_RLED_PORT,c_RLED_PIN    ;Controlla se led acceso o spento
        CLRF R3H                        ;Acceso, accende anche gli altri
        BCF f_CTR_P6                    ;clear flag esecuzione Programma
        CALL Port_Write                 ;Scrive sulle uscite
        RETURN                          ;fine

Port_Write:
;Questa routine scrive sulle porte
;Registri modificati:
;       sistema
;       R3H
;       PORTA
;       PORTB
;metodo di chiamata:
;       MOVLF dato,R3H
;       CALL Port_Write
;
        MOVFF R3H,PORTB                 ;scrive PORTB
        BTFSC R3H,6                     ;
        GOTO PW_001                     ;
        BCF PORTA,6                     ;clear bit 6
        GOTO PW_002                     ;
PW_001  BSF PORTA,6                     ;set bit 6
PW_002  BTFSC R3H,7                     ;
        GOTO PW_003                     ;
        BCF PORTA,7                     ;clear bit 7
        RETURN                          ;
PW_003  BSF PORTA,7                     ;set bit 7
        RETURN                          ;fine
